#!/usr/local/bin/perl -wT
# Copyright Andru Luvisi, 1999
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program (see the file COPYING); if not, write to the
# Free Software Foundation, Inc.,
# 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA


use strict;
use vars qw($mask $len $lastoff);

open(WORDS, "/usr/dict/words") || die("Can't open words");
open(MASKS, ">anamasks.dat") || die("Can't open anamasks.dat");

$lastoff = 0;
while(<WORDS>) {
 chomp;
 $len = length($_);
 $mask = makemask($_, $len, $len);
 print MASKS $mask, pack("L", $lastoff);
 $lastoff = tell(WORDS);
}

close(MASKS);
close(WORDS);
exit(0);



# create a bitmask of the letters used in the word
sub makemask {
 my $word = shift;
 my $minlen = shift;
 my $maxlen = shift;
 my $mask = "\000" x 60;
 my $offset;

 while($word =~ /[A-Za-z]/g) {
  $offset = (ord(lc($&)) - 97);
  vec($mask, $offset, 16) = 1 | (vec($mask, $offset, 16) << 1);
 }
 vec($mask, 13, 32) = ~0 << $minlen;      # encode length for minimum testing
 vec($mask, 14, 32) = ~0 >> 32 - $maxlen; # encode length for maximum testing

 return $mask;
}

